stages:
  - prepare
#   - build
  - deploy

variables:
  IMAGE_REGISTRY: 65.108.52.119:5000
  IMAGE_NAME: mlflow_task
  SWARM_MANAGER: 65.108.52.119
  ORIGIN_NAME: origin
  SERVICE_NAME: web_app_9
  TAG_NEW: pyfunc


prepare-job-get-secret:
  stage: prepare
  image: python:3.9
  rules:
    - if: '$CI_COMMIT_BRANCH == "TEST" || $CI_COMMIT_BRANCH == "PROD" || $CI_COMMIT_BRANCH == "master"'
  services:
    - name: waryak/karpov_courses:secret_ci_service
      alias: waryak
  before_script: []
  script:
    - apt-get update
    - apt-get -y install jq
    - response=$(curl -s http://waryak:5000/get_iris_thresholds)
    - echo $response
    # - threshold_0_1=$(echo "$response" | awk -F'[:,]' '{if ($2 ~ /threshold_0_1/) {print $3}}' | tr -d '[:space:]')
    # - threshold_1_2=$(echo "$response" | awk -F'[:,]' '{if ($4 ~ /threshold_1_2/) {print $5}}' | tr -d '[:space:]')
    - threshold_0_1=$(echo "$response" | jq -r '.threshold_0_1')
    - threshold_1_2=$(echo "$response" | jq -r '.threshold_1_2')
    - export THRESHOLD_0_1=$threshold_0_1
    - export THRESHOLD_1_2=$threshold_1_2

    - echo $THRESHOLD_0_1
    - echo $THRESHOLD_1_2
    - echo $THRESHOLD_0_1 > ./threshold_0_1.txt
    - echo $THRESHOLD_1_2 > ./threshold_1_2.txt
  artifacts:
      paths:
        - ./threshold_0_1.txt
        - ./threshold_1_2.txt

before_script:
  - 'which ssh-agent || ( apt-get install -qq openssh-client )'
  - eval $(ssh-agent -s)
  - mkdir -p ~/.ssh
  - 'echo -e "Host *\n\tStrictHostKeyChecking no\n\n" > ~/.ssh/config'
  - echo "${SSH_PRIVATE_KEY_ENCODED}" | base64 --decode | ssh-add -
  - ssh root@$SWARM_MANAGER "ls"
  - echo "Successfuly connected to remote server."

# build-job:
#   stage: build
#   rules:
#     - if: '$CI_COMMIT_BRANCH == "TEST" || $CI_COMMIT_BRANCH == "PROD"'

#   script:
#     - ssh root@$SWARM_MANAGER "cd $CI_PROJECT_NAME && git fetch $ORIGIN_NAME $CI_COMMIT_BRANCH && git checkout $CI_COMMIT_BRANCH"
#     - ssh root@$SWARM_MANAGER "cd $CI_PROJECT_NAME && git pull $ORIGIN_NAME $CI_COMMIT_BRANCH"
#     - ssh root@$SWARM_MANAGER " cd $CI_PROJECT_NAME &&
#                                 docker image rm $IMAGE_REGISTRY/$IMAGE_NAME ;
#                                 docker build -t $IMAGE_NAME . &&
#                                 docker tag  $IMAGE_NAME  $IMAGE_REGISTRY/$IMAGE_NAME &&
#                                 docker push $IMAGE_REGISTRY/$IMAGE_NAME"
  

deploy-job:
  stage: deploy
  rules:
    - if: '$CI_COMMIT_BRANCH == "TEST" || $CI_COMMIT_BRANCH == "PROD" || $CI_COMMIT_BRANCH == "master"'

  environment: production
  script:
    - export THRESHOLD_0_1=$(cat ./threshold_0_1.txt)
    - export THRESHOLD_1_2=$(cat ./threshold_1_2.txt)
    - echo $THRESHOLD_1_2
    - ssh root@$SWARM_MANAGER "cd $CI_PROJECT_NAME && docker service update --image $IMAGE_REGISTRY/$IMAGE_NAME:$TAG_NEW --env-add THRESHOLD_0_1=$THRESHOLD_0_1 --env-add	THRESHOLD_1_2=$THRESHOLD_1_2 $SERVICE_NAME"
    # - ssh root@$SWARM_MANAGER "docker service create -d --replicas 1  --name web_app_6_1_$SOURCE_BRANCH_LOW --publish 5002:5002 -e SERVICE_PORT=5002 -e SECRET_NUMBER=$SECRET_NUMBER $IMAGE_REGISTRY/$IMAGE_NAME"

